/* encoding.c generated by valac 0.16.0, the Vala compiler
 * generated from encoding.vala, do not modify */

/*
 * Copyright (C) 2011-2012 Daiki Ueno <ueno@unixuser.org>
 * Copyright (C) 2011-2012 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>


#define SKK_TYPE_ENCODING_CONVERTER (skk_encoding_converter_get_type ())
#define SKK_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverter))
#define SKK_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))
#define SKK_IS_ENCODING_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_IS_ENCODING_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SKK_TYPE_ENCODING_CONVERTER))
#define SKK_ENCODING_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterClass))

typedef struct _SkkEncodingConverter SkkEncodingConverter;
typedef struct _SkkEncodingConverterClass SkkEncodingConverterClass;
typedef struct _SkkEncodingConverterPrivate SkkEncodingConverterPrivate;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define SKK_TYPE_ENTRY (skk_entry_get_type ())
typedef struct _SkkEntry SkkEntry;
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SkkEncodingConverter {
	GObject parent_instance;
	SkkEncodingConverterPrivate * priv;
};

struct _SkkEncodingConverterClass {
	GObjectClass parent_class;
};

struct _SkkEncodingConverterPrivate {
	gchar* _encoding;
	GCharsetConverter* encoder;
	GCharsetConverter* decoder;
};

struct _SkkEntry {
	gpointer key;
	gpointer value;
};


static gpointer skk_encoding_converter_parent_class = NULL;
static GRegex* skk_encoding_converter_coding_cookie_regex;
static GRegex* skk_encoding_converter_coding_cookie_regex = NULL;

GType skk_encoding_converter_get_type (void) G_GNUC_CONST;
#define SKK_ENCODING_CONVERTER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), SKK_TYPE_ENCODING_CONVERTER, SkkEncodingConverterPrivate))
enum  {
	SKK_ENCODING_CONVERTER_DUMMY_PROPERTY,
	SKK_ENCODING_CONVERTER_ENCODING
};
#define SKK_ENCODING_CONVERTER_BUFSIZ 4096
#define SKK_ENCODING_CONVERTER_INTERNAL_ENCODING "UTF-8"
GType skk_entry_get_type (void) G_GNUC_CONST;
SkkEntry* skk_entry_dup (const SkkEntry* self);
void skk_entry_free (SkkEntry* self);
void skk_entry_copy (const SkkEntry* self, SkkEntry* dest);
void skk_entry_destroy (SkkEntry* self);
gchar* skk_encoding_converter_extract_coding_system (const gchar* line);
gchar* skk_encoding_converter_get_coding_system (SkkEncodingConverter* self);
const gchar* skk_encoding_converter_get_encoding (SkkEncodingConverter* self);
SkkEncodingConverter* skk_encoding_converter_new (const gchar* encoding, GError** error);
SkkEncodingConverter* skk_encoding_converter_construct (GType object_type, const gchar* encoding, GError** error);
static void skk_encoding_converter_set_encoding (SkkEncodingConverter* self, const gchar* value);
SkkEncodingConverter* skk_encoding_converter_new_from_coding_system (const gchar* coding, GError** error);
SkkEncodingConverter* skk_encoding_converter_construct_from_coding_system (GType object_type, const gchar* coding, GError** error);
static gchar* skk_encoding_converter_convert (SkkEncodingConverter* self, GCharsetConverter* converter, const gchar* str, GError** error);
static guint8* _vala_array_dup1 (guint8* self, int length);
gchar* skk_encoding_converter_encode (SkkEncodingConverter* self, const gchar* internal_str, GError** error);
gchar* skk_encoding_converter_decode (SkkEncodingConverter* self, const gchar* external_str, GError** error);
static void skk_encoding_converter_finalize (GObject* obj);
static void _vala_skk_encoding_converter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_skk_encoding_converter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);

static const SkkEntry SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE[7] = {{"UTF-8", "utf-8"}, {"EUC-JP", "euc-jp"}, {"Shift_JIS", "shift_jis"}, {"ISO-2022-JP", "iso-2022-jp"}, {"EUC-JISX0213", "euc-jisx0213"}, {"EUC-JISX0213", "euc-jis-2004"}, {"SHIFT_JISX0213", "shift_jis-2004"}};

gchar* skk_encoding_converter_extract_coding_system (const gchar* line) {
	gchar* result = NULL;
	GMatchInfo* info;
	GRegex* _tmp0_;
	const gchar* _tmp1_;
	GMatchInfo* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
#line 46 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 47 "/home/ueno/devel/libskk/libskk/encoding.vala"
	info = NULL;
#line 48 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp0_ = skk_encoding_converter_coding_cookie_regex;
#line 48 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp1_ = line;
#line 48 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp3_ = g_regex_match (_tmp0_, _tmp1_, 0, &_tmp2_);
#line 48 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_match_info_free0 (info);
#line 48 "/home/ueno/devel/libskk/libskk/encoding.vala"
	info = _tmp2_;
#line 48 "/home/ueno/devel/libskk/libskk/encoding.vala"
	if (_tmp3_) {
#line 129 "encoding.c"
		GMatchInfo* _tmp4_;
		gchar* _tmp5_ = NULL;
#line 49 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp4_ = info;
#line 49 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp5_ = g_match_info_fetch (_tmp4_, 1);
#line 49 "/home/ueno/devel/libskk/libskk/encoding.vala"
		result = _tmp5_;
#line 49 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_g_match_info_free0 (info);
#line 49 "/home/ueno/devel/libskk/libskk/encoding.vala"
		return result;
#line 142 "encoding.c"
	}
#line 51 "/home/ueno/devel/libskk/libskk/encoding.vala"
	result = NULL;
#line 51 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_match_info_free0 (info);
#line 51 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return result;
#line 150 "encoding.c"
}


gchar* skk_encoding_converter_get_coding_system (SkkEncodingConverter* self) {
	gchar* result = NULL;
#line 54 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 158 "encoding.c"
	{
		SkkEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 55 "/home/ueno/devel/libskk/libskk/encoding.vala"
		entry_collection = SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE;
#line 55 "/home/ueno/devel/libskk/libskk/encoding.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE);
#line 55 "/home/ueno/devel/libskk/libskk/encoding.vala"
		for (entry_it = 0; entry_it < G_N_ELEMENTS (SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE); entry_it = entry_it + 1) {
#line 170 "encoding.c"
			SkkEntry entry = {0};
#line 55 "/home/ueno/devel/libskk/libskk/encoding.vala"
			entry = entry_collection[entry_it];
#line 174 "encoding.c"
			{
				SkkEntry _tmp0_;
				gconstpointer _tmp1_;
				const gchar* _tmp2_;
#line 56 "/home/ueno/devel/libskk/libskk/encoding.vala"
				_tmp0_ = entry;
#line 56 "/home/ueno/devel/libskk/libskk/encoding.vala"
				_tmp1_ = _tmp0_.key;
#line 56 "/home/ueno/devel/libskk/libskk/encoding.vala"
				_tmp2_ = self->priv->_encoding;
#line 56 "/home/ueno/devel/libskk/libskk/encoding.vala"
				if (g_strcmp0 ((const gchar*) _tmp1_, _tmp2_) == 0) {
#line 187 "encoding.c"
					SkkEntry _tmp3_;
					gconstpointer _tmp4_;
					gchar* _tmp5_;
#line 57 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp3_ = entry;
#line 57 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp4_ = _tmp3_.value;
#line 57 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp5_ = g_strdup ((const gchar*) _tmp4_);
#line 57 "/home/ueno/devel/libskk/libskk/encoding.vala"
					result = _tmp5_;
#line 57 "/home/ueno/devel/libskk/libskk/encoding.vala"
					return result;
#line 201 "encoding.c"
				}
			}
		}
	}
#line 60 "/home/ueno/devel/libskk/libskk/encoding.vala"
	result = NULL;
#line 60 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return result;
#line 210 "encoding.c"
}


SkkEncodingConverter* skk_encoding_converter_construct (GType object_type, const gchar* encoding, GError** error) {
	SkkEncodingConverter * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GCharsetConverter* _tmp2_;
	GCharsetConverter* _tmp3_;
	const gchar* _tmp4_;
	GCharsetConverter* _tmp5_;
	GCharsetConverter* _tmp6_;
	GError * _inner_error_ = NULL;
#line 68 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (encoding != NULL, NULL);
#line 68 "/home/ueno/devel/libskk/libskk/encoding.vala"
	self = (SkkEncodingConverter*) g_object_new (object_type, NULL);
#line 69 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp0_ = encoding;
#line 69 "/home/ueno/devel/libskk/libskk/encoding.vala"
	skk_encoding_converter_set_encoding (self, _tmp0_);
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp1_ = encoding;
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp2_ = g_charset_converter_new (_tmp1_, SKK_ENCODING_CONVERTER_INTERNAL_ENCODING, &_inner_error_);
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp3_ = _tmp2_;
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
	if (_inner_error_ != NULL) {
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_propagate_error (error, _inner_error_);
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_g_object_unref0 (self);
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
		return NULL;
#line 246 "encoding.c"
	}
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_object_unref0 (self->priv->encoder);
#line 70 "/home/ueno/devel/libskk/libskk/encoding.vala"
	self->priv->encoder = _tmp3_;
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp4_ = encoding;
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp5_ = g_charset_converter_new (SKK_ENCODING_CONVERTER_INTERNAL_ENCODING, _tmp4_, &_inner_error_);
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp6_ = _tmp5_;
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
	if (_inner_error_ != NULL) {
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_propagate_error (error, _inner_error_);
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_g_object_unref0 (self);
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
		return NULL;
#line 266 "encoding.c"
	}
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_object_unref0 (self->priv->decoder);
#line 71 "/home/ueno/devel/libskk/libskk/encoding.vala"
	self->priv->decoder = _tmp6_;
#line 68 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return self;
#line 274 "encoding.c"
}


SkkEncodingConverter* skk_encoding_converter_new (const gchar* encoding, GError** error) {
#line 68 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return skk_encoding_converter_construct (SKK_TYPE_ENCODING_CONVERTER, encoding, error);
#line 281 "encoding.c"
}


SkkEncodingConverter* skk_encoding_converter_construct_from_coding_system (GType object_type, const gchar* coding, GError** error) {
	SkkEncodingConverter * self = NULL;
	GError * _inner_error_ = NULL;
#line 74 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (coding != NULL, NULL);
#line 290 "encoding.c"
	{
		SkkEntry* entry_collection = NULL;
		gint entry_collection_length1 = 0;
		gint _entry_collection_size_ = 0;
		gint entry_it = 0;
#line 75 "/home/ueno/devel/libskk/libskk/encoding.vala"
		entry_collection = SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE;
#line 75 "/home/ueno/devel/libskk/libskk/encoding.vala"
		entry_collection_length1 = G_N_ELEMENTS (SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE);
#line 75 "/home/ueno/devel/libskk/libskk/encoding.vala"
		for (entry_it = 0; entry_it < G_N_ELEMENTS (SKK_ENCODING_CONVERTER_ENCODING_TO_CODING_SYSTEM_RULE); entry_it = entry_it + 1) {
#line 302 "encoding.c"
			SkkEntry entry = {0};
#line 75 "/home/ueno/devel/libskk/libskk/encoding.vala"
			entry = entry_collection[entry_it];
#line 306 "encoding.c"
			{
				SkkEntry _tmp0_;
				gconstpointer _tmp1_;
				const gchar* _tmp2_;
#line 76 "/home/ueno/devel/libskk/libskk/encoding.vala"
				_tmp0_ = entry;
#line 76 "/home/ueno/devel/libskk/libskk/encoding.vala"
				_tmp1_ = _tmp0_.value;
#line 76 "/home/ueno/devel/libskk/libskk/encoding.vala"
				_tmp2_ = coding;
#line 76 "/home/ueno/devel/libskk/libskk/encoding.vala"
				if (g_strcmp0 ((const gchar*) _tmp1_, _tmp2_) == 0) {
#line 319 "encoding.c"
					SkkEntry _tmp3_;
					gconstpointer _tmp4_;
#line 77 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp3_ = entry;
#line 77 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp4_ = _tmp3_.key;
#line 77 "/home/ueno/devel/libskk/libskk/encoding.vala"
					self = (SkkEncodingConverter*) skk_encoding_converter_construct (object_type, (const gchar*) _tmp4_, &_inner_error_);
#line 77 "/home/ueno/devel/libskk/libskk/encoding.vala"
					if (_inner_error_ != NULL) {
#line 77 "/home/ueno/devel/libskk/libskk/encoding.vala"
						g_propagate_error (error, _inner_error_);
#line 77 "/home/ueno/devel/libskk/libskk/encoding.vala"
						_g_object_unref0 (self);
#line 77 "/home/ueno/devel/libskk/libskk/encoding.vala"
						return NULL;
#line 336 "encoding.c"
					}
#line 78 "/home/ueno/devel/libskk/libskk/encoding.vala"
					return self;
#line 340 "encoding.c"
				}
			}
		}
	}
#line 81 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_assert_not_reached ();
#line 74 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return self;
#line 349 "encoding.c"
}


SkkEncodingConverter* skk_encoding_converter_new_from_coding_system (const gchar* coding, GError** error) {
#line 74 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return skk_encoding_converter_construct_from_coding_system (SKK_TYPE_ENCODING_CONVERTER, coding, error);
#line 356 "encoding.c"
}


static guint8* string_get_data (const gchar* self, int* result_length1) {
	guint8* result;
	guint8* res;
	gint res_length1;
	gint _res_size_;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* _tmp4_;
	gint _tmp4__length1;
#line 1407 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	res = (guint8*) self;
#line 1408 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	res_length1 = -1;
#line 1408 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_res_size_ = res_length1;
#line 1409 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1409 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1409 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	res_length1 = (gint) _tmp1_;
#line 1409 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp2_ = res_length1;
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3_ = res;
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp3__length1 = res_length1;
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	_tmp4__length1 = _tmp3__length1;
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	if (result_length1) {
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
		*result_length1 = _tmp4__length1;
#line 400 "encoding.c"
	}
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	result = _tmp4_;
#line 1410 "/usr/share/vala-0.16/vapi/glib-2.0.vapi"
	return result;
#line 406 "encoding.c"
}


static guint8* _vala_array_dup1 (guint8* self, int length) {
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return g_memdup (self, length * sizeof (guint8));
#line 413 "encoding.c"
}


static gchar* skk_encoding_converter_convert (SkkEncodingConverter* self, GCharsetConverter* converter, const gchar* str, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_;
	guint8* _tmp1_;
	gint _tmp1__length1;
	guint8* _tmp2_;
	gint _tmp2__length1;
	guint8* _tmp3_;
	gint _tmp3__length1;
	guint8* inbuf;
	gint inbuf_length1;
	gint _inbuf_size_;
	guint8* _tmp4_ = NULL;
	guint8* outbuf;
	gint outbuf_length1;
	gint _outbuf_size_;
	GString* _tmp5_;
	GString* builder;
	gsize total_bytes_read;
	GString* _tmp26_;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	GError * _inner_error_ = NULL;
#line 84 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (converter != NULL, NULL);
#line 84 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp0_ = str;
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp1_ = string_get_data (_tmp0_, &_tmp1__length1);
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp2_ = _tmp1_;
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp2__length1 = _tmp1__length1;
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp3_ = (_tmp2_ != NULL) ? _vala_array_dup1 (_tmp2_, _tmp2__length1) : ((gpointer) _tmp2_);
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp3__length1 = _tmp2__length1;
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	inbuf = _tmp3_;
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	inbuf_length1 = _tmp3__length1;
#line 85 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_inbuf_size_ = inbuf_length1;
#line 86 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp4_ = g_new0 (guint8, SKK_ENCODING_CONVERTER_BUFSIZ);
#line 86 "/home/ueno/devel/libskk/libskk/encoding.vala"
	outbuf = _tmp4_;
#line 86 "/home/ueno/devel/libskk/libskk/encoding.vala"
	outbuf_length1 = SKK_ENCODING_CONVERTER_BUFSIZ;
#line 86 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_outbuf_size_ = outbuf_length1;
#line 87 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp5_ = g_string_new ("");
#line 87 "/home/ueno/devel/libskk/libskk/encoding.vala"
	builder = _tmp5_;
#line 88 "/home/ueno/devel/libskk/libskk/encoding.vala"
	total_bytes_read = (gsize) 0;
#line 89 "/home/ueno/devel/libskk/libskk/encoding.vala"
	while (TRUE) {
#line 480 "encoding.c"
		gsize _tmp6_;
		guint8* _tmp7_;
		gint _tmp7__length1;
		gsize bytes_read = 0UL;
		gsize bytes_written = 0UL;
		GCharsetConverter* _tmp8_;
		guint8* _tmp9_;
		gint _tmp9__length1;
		gsize _tmp10_;
		guint8* _tmp11_;
		gint _tmp11__length1;
		guint8* _tmp12_;
		gint _tmp12__length1;
		gsize _tmp13_ = 0UL;
		gsize _tmp14_ = 0UL;
		gsize _tmp24_;
		gsize _tmp25_;
#line 89 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp6_ = total_bytes_read;
#line 89 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp7_ = inbuf;
#line 89 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp7__length1 = inbuf_length1;
#line 89 "/home/ueno/devel/libskk/libskk/encoding.vala"
		if (!(_tmp6_ < ((gsize) _tmp7__length1))) {
#line 89 "/home/ueno/devel/libskk/libskk/encoding.vala"
			break;
#line 508 "encoding.c"
		}
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp8_ = converter;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp9_ = inbuf;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp9__length1 = inbuf_length1;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp10_ = total_bytes_read;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp11_ = inbuf;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp11__length1 = inbuf_length1;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp12_ = outbuf;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp12__length1 = outbuf_length1;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_converter_convert ((GConverter*) _tmp8_, _tmp9_ + _tmp10_, (gsize) (_tmp11__length1 - _tmp10_), (void*) _tmp12_, (gsize) _tmp12__length1, G_CONVERTER_INPUT_AT_END, &_tmp13_, &_tmp14_, &_inner_error_);
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		bytes_read = _tmp13_;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		bytes_written = _tmp14_;
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
		if (_inner_error_ != NULL) {
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
			g_propagate_error (error, _inner_error_);
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
			_g_string_free0 (builder);
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
			outbuf = (g_free (outbuf), NULL);
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
			inbuf = (g_free (inbuf), NULL);
#line 96 "/home/ueno/devel/libskk/libskk/encoding.vala"
			return NULL;
#line 544 "encoding.c"
		}
		{
			gint i;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
			i = 0;
#line 550 "encoding.c"
			{
				gboolean _tmp15_;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
				_tmp15_ = TRUE;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
				while (TRUE) {
#line 557 "encoding.c"
					gboolean _tmp16_;
					gint _tmp18_;
					gsize _tmp19_;
					GString* _tmp20_;
					guint8* _tmp21_;
					gint _tmp21__length1;
					gint _tmp22_;
					guint8 _tmp23_;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp16_ = _tmp15_;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
					if (!_tmp16_) {
#line 570 "encoding.c"
						gint _tmp17_;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
						_tmp17_ = i;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
						i = _tmp17_ + 1;
#line 576 "encoding.c"
					}
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp15_ = FALSE;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp18_ = i;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp19_ = bytes_written;
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
					if (!(((gsize) _tmp18_) < _tmp19_)) {
#line 101 "/home/ueno/devel/libskk/libskk/encoding.vala"
						break;
#line 588 "encoding.c"
					}
#line 102 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp20_ = builder;
#line 102 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp21_ = outbuf;
#line 102 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp21__length1 = outbuf_length1;
#line 102 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp22_ = i;
#line 102 "/home/ueno/devel/libskk/libskk/encoding.vala"
					_tmp23_ = _tmp21_[_tmp22_];
#line 102 "/home/ueno/devel/libskk/libskk/encoding.vala"
					g_string_append_c (_tmp20_, (gchar) _tmp23_);
#line 602 "encoding.c"
				}
			}
		}
#line 103 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp24_ = total_bytes_read;
#line 103 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp25_ = bytes_read;
#line 103 "/home/ueno/devel/libskk/libskk/encoding.vala"
		total_bytes_read = _tmp24_ + _tmp25_;
#line 612 "encoding.c"
	}
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp26_ = builder;
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp27_ = _tmp26_->str;
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp28_ = g_strdup (_tmp27_);
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	result = _tmp28_;
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_string_free0 (builder);
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	outbuf = (g_free (outbuf), NULL);
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	inbuf = (g_free (inbuf), NULL);
#line 105 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return result;
#line 630 "encoding.c"
}


gchar* skk_encoding_converter_encode (SkkEncodingConverter* self, const gchar* internal_str, GError** error) {
	gchar* result = NULL;
	GCharsetConverter* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
#line 108 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 108 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (internal_str != NULL, NULL);
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp0_ = self->priv->encoder;
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp1_ = internal_str;
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp2_ = skk_encoding_converter_convert (self, _tmp0_, _tmp1_, &_inner_error_);
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp3_ = _tmp2_;
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
	if (_inner_error_ != NULL) {
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_propagate_error (error, _inner_error_);
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
		return NULL;
#line 659 "encoding.c"
	}
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
	result = _tmp3_;
#line 109 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return result;
#line 665 "encoding.c"
}


gchar* skk_encoding_converter_decode (SkkEncodingConverter* self, const gchar* external_str, GError** error) {
	gchar* result = NULL;
	GCharsetConverter* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
#line 112 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 112 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (external_str != NULL, NULL);
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp0_ = self->priv->decoder;
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp1_ = external_str;
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp2_ = skk_encoding_converter_convert (self, _tmp0_, _tmp1_, &_inner_error_);
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp3_ = _tmp2_;
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
	if (_inner_error_ != NULL) {
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_propagate_error (error, _inner_error_);
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
		return NULL;
#line 694 "encoding.c"
	}
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
	result = _tmp3_;
#line 113 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return result;
#line 700 "encoding.c"
}


const gchar* skk_encoding_converter_get_encoding (SkkEncodingConverter* self) {
	const gchar* result;
	const gchar* _tmp0_;
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp0_ = self->priv->_encoding;
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	result = _tmp0_;
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	return result;
#line 715 "encoding.c"
}


static void skk_encoding_converter_set_encoding (SkkEncodingConverter* self, const gchar* value) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_return_if_fail (self != NULL);
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp0_ = value;
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_free0 (self->priv->_encoding);
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	self->priv->_encoding = _tmp1_;
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_object_notify ((GObject *) self, "encoding");
#line 734 "encoding.c"
}


static void skk_encoding_converter_class_init (SkkEncodingConverterClass * klass) {
	GError * _inner_error_ = NULL;
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	skk_encoding_converter_parent_class = g_type_class_peek_parent (klass);
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_type_class_add_private (klass, sizeof (SkkEncodingConverterPrivate));
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_skk_encoding_converter_get_property;
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_skk_encoding_converter_set_property;
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	G_OBJECT_CLASS (klass)->finalize = skk_encoding_converter_finalize;
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SKK_ENCODING_CONVERTER_ENCODING, g_param_spec_string ("encoding", "encoding", "encoding", NULL, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE));
#line 752 "encoding.c"
	{
		GRegex* _tmp0_;
		GRegex* _tmp1_;
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp0_ = g_regex_new ("-\\*-.*[ \t]coding:[ \t]*([^ \t;]+?)[ \t;].*-\\*-", 0, 0, &_inner_error_);
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_tmp1_ = _tmp0_;
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
		if (_inner_error_ != NULL) {
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
			if (_inner_error_->domain == G_REGEX_ERROR) {
#line 764 "encoding.c"
				goto __catch1_g_regex_error;
			}
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
			g_clear_error (&_inner_error_);
#line 771 "encoding.c"
		}
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_g_regex_unref0 (skk_encoding_converter_coding_cookie_regex);
#line 39 "/home/ueno/devel/libskk/libskk/encoding.vala"
		skk_encoding_converter_coding_cookie_regex = _tmp1_;
#line 777 "encoding.c"
	}
	goto __finally1;
	__catch1_g_regex_error:
	{
		GError* e = NULL;
#line 38 "/home/ueno/devel/libskk/libskk/encoding.vala"
		e = _inner_error_;
#line 38 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_inner_error_ = NULL;
#line 42 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_assert_not_reached ();
#line 38 "/home/ueno/devel/libskk/libskk/encoding.vala"
		_g_error_free0 (e);
#line 791 "encoding.c"
	}
	__finally1:
#line 38 "/home/ueno/devel/libskk/libskk/encoding.vala"
	if (_inner_error_ != NULL) {
#line 38 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 38 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_clear_error (&_inner_error_);
#line 800 "encoding.c"
	}
}


static void skk_encoding_converter_instance_init (SkkEncodingConverter * self) {
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	self->priv = SKK_ENCODING_CONVERTER_GET_PRIVATE (self);
#line 808 "encoding.c"
}


static void skk_encoding_converter_finalize (GObject* obj) {
	SkkEncodingConverter * self;
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	self = SKK_ENCODING_CONVERTER (obj);
#line 63 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_free0 (self->priv->_encoding);
#line 65 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_object_unref0 (self->priv->encoder);
#line 66 "/home/ueno/devel/libskk/libskk/encoding.vala"
	_g_object_unref0 (self->priv->decoder);
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	G_OBJECT_CLASS (skk_encoding_converter_parent_class)->finalize (obj);
#line 824 "encoding.c"
}


GType skk_encoding_converter_get_type (void) {
	static volatile gsize skk_encoding_converter_type_id__volatile = 0;
	if (g_once_init_enter (&skk_encoding_converter_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SkkEncodingConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) skk_encoding_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SkkEncodingConverter), 0, (GInstanceInitFunc) skk_encoding_converter_instance_init, NULL };
		GType skk_encoding_converter_type_id;
		skk_encoding_converter_type_id = g_type_register_static (G_TYPE_OBJECT, "SkkEncodingConverter", &g_define_type_info, 0);
		g_once_init_leave (&skk_encoding_converter_type_id__volatile, skk_encoding_converter_type_id);
	}
	return skk_encoding_converter_type_id__volatile;
}


static void _vala_skk_encoding_converter_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SkkEncodingConverter * self;
	self = SKK_ENCODING_CONVERTER (object);
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	switch (property_id) {
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		case SKK_ENCODING_CONVERTER_ENCODING:
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		g_value_set_string (value, skk_encoding_converter_get_encoding (self));
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		break;
#line 851 "encoding.c"
		default:
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		break;
#line 857 "encoding.c"
	}
}


static void _vala_skk_encoding_converter_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SkkEncodingConverter * self;
	self = SKK_ENCODING_CONVERTER (object);
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
	switch (property_id) {
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		case SKK_ENCODING_CONVERTER_ENCODING:
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		skk_encoding_converter_set_encoding (self, g_value_get_string (value));
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		break;
#line 873 "encoding.c"
		default:
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "/home/ueno/devel/libskk/libskk/encoding.vala"
		break;
#line 879 "encoding.c"
	}
}



